/* This file is part of smap.
   Copyright (C) 2006, 2007, 2010 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <syslog.h>
#include "smap/diag.h"

static void
flush_syslog(void *data, char *buf)
{
	int prio = (int)data;
	syslog(prio, "%s", buf);
}

void
smap_openlog_syslog(char *tag, int opts, int facility, int trace)
{
	smap_ostream_destroy(&smap_error_str);
	smap_ostream_destroy(&smap_debug_str);
	smap_ostream_destroy(&smap_trace_str);

	openlog(tag, opts, facility);
	smap_error_str = smap_ostream_create(flush_syslog,
					     (void*) LOG_ERR);
	smap_debug_str = smap_ostream_create(flush_syslog,
					     (void*) LOG_DEBUG);
	if (trace)
		smap_trace_str = smap_ostream_create(flush_syslog,
						     (void*) LOG_INFO);
}
